import static java.lang.Character.isLowerCase;
import static java.lang.Character.isUpperCase;
import static java.lang.Character.toLowerCase;

public class ROT13  {

    int rotateBy = 13;

    private char[] rotatedAlphbet;
    private char[] alphChars = "abcdefghijklmnopqrstuvwxyz".toCharArray();

    ROT13(Character cs, Character cf) {
        rotateBy = numbersByCount(cs, cf);
        rotatedAlphbet = rotate("abcdefghijklmnopqrstuvwxyz", cf).toCharArray();
    }

    ROT13() {}

    public static int numbersByCount(Character cs, Character cf){
        String alphabet = "abcdefghijklmnopqrstuvwxyz";
        char[] alphChars = alphabet.toCharArray();

        int counter = 0;
        for(int i = 0; i < alphChars.length; i++){
            if(counter == 0){
                if(alphChars[i] == cs){
                    counter++;
                }
            } else if(alphChars[i] != cf){
                counter++;
            } else{
                break;
            }
        }
        return counter;

    }

    public static void main(String[] args){
        new ROT13('a','n');
        //System.out.println(new ROT13().crypt("Gb trg gb gur bgure fvqr!"));
    }

    public String crypt(String text) throws UnsupportedOperationException {
        StringBuilder sb = new StringBuilder();
        char[] cars = text.toCharArray();

        for(char car: cars){
            if(Character.isLetter(car)){
                if(Character.isUpperCase(car)){
                    sb.append(Character.toUpperCase(charShift(car)));
                }else {
                    sb.append(charShift(car));
                }
            } else{
                sb.append(car);
            }

        }
        return sb.toString();

    }

    private Character charShift(char c){
        Character car = null;
        for(int i = 0; i < this.alphChars.length; i++) {
            if(this.alphChars[i] == Character.toLowerCase(c)){
                car = this.rotatedAlphbet[i];
                break;
            }
        }
        return car;
    }

    public String encrypt(String text) {
        return this.crypt(text);
    }

    public String decrypt(String text) {

        return this.crypt(text);
    }

    public static String rotate(String s, Character c) {
        char[] cars = s.toCharArray();

        char temp;
        while(cars[0] != c){
            temp = cars[0];
            for(int i = 0; i < cars.length -1; i++){
                cars[i] = cars[i +1];
            }
            cars[cars.length -1] = temp;
        }

        return new String(cars);
    }



}
